#ifndef LIB_DBG_DEBUG_TYPE_TO_STRING_MQH_INCLUDED
#define LIB_DBG_DEBUG_TYPE_TO_STRING_MQH_INCLUDED
#property version "5.50"
/**********************************************************************************
 * Copyright (C) 2020 Dominik Egert <info@freie-netze.de>
 *
 * This file is the debugger generic type to string library include file.
 *
 * Lisence applied: GPLv2
 *                  https://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 *
 * Author Dominik Egert / Freie Netze UG.
 **********************************************************************************
 *
 *  Version: 4120
 *  State: public
 *
 *  File information
 *  ================
 *
*/




#ifdef __MQLPLUS_MQL4_COMPATIBLITY__
    #define __INCLUDE_MQL5_ENUMS__
    #define __INCLUDE_MQL5_DATATYPES__

#endif
#ifndef __MQL4__
    #define __INCLUDE_MQL5_ENUMS__
    #define __INCLUDE_MQL5_DATATYPES__

#endif


//*********************************************************************************************************************************************************/
// Begin Debugging support functions
//


    // Overloaded functions
    #ifndef LIB_DEBUG_NAMESPACE
        #ifndef __MQL4__
            namespace dbg_lib
            {

        #endif

        // Stringify known enums

            template <typename T>
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(const string name, const T                                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(StringFormat("%s[enum] %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = %-25s (%s) [%s]",      prefix,       LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name),     EnumToString(val), (hex) ? StringFormat("0x%08X", (int)val) : LIB_DBG_NAMESPACE(dbg_lib, bits_out)((uint)val), typename_raw(val))); }


        // Unknown objects

            template <typename T>
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, eval_unknown_type)(const string name, T&                                    val,    string& enum_name)                                                                                              { return((StringFind(typename(val), "enum ") == 0) ? "" : NULL); };


        // Known enumerations

            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ACCOUNT_INFO_DOUBLE                        val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ACCOUNT_INFO_INTEGER                       val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ACCOUNT_INFO_STRING                        val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ACCOUNT_MARGIN_MODE                        val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ACCOUNT_STOPOUT_MODE                       val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ACCOUNT_TRADE_MODE                         val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ACTIVATION_FUNCTION                        val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ALIGN_MODE                                 val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ANCHOR_POINT                               val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_APPLIED_PRICE                              val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_APPLIED_VOLUME                             val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ARROW_ANCHOR                               val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_BASE_CORNER                                val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_BOOK_TYPE                                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_BORDER_TYPE                                val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CALENDAR_EVENT_FREQUENCY                   val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CALENDAR_EVENT_IMPACT                      val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CALENDAR_EVENT_IMPORTANCE                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CALENDAR_EVENT_MULTIPLIER                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CALENDAR_EVENT_SECTOR                      val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CALENDAR_EVENT_TIMEMODE                    val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CALENDAR_EVENT_TYPE                        val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CALENDAR_EVENT_UNIT                        val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CHART_EVENT                                val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CHART_MODE                                 val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CHART_POSITION                             val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CHART_PROPERTY_DOUBLE                      val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CHART_PROPERTY_INTEGER                     val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CHART_PROPERTY_STRING                      val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CHART_VOLUME_MODE                          val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CL_DEVICE_TYPE                             val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_COLOR_FORMAT                               val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_COPY_RATES                                 val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_COPY_TICKS                                 val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CRYPT_METHOD                               val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CUSTOMIND_PROPERTY_DOUBLE                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CUSTOMIND_PROPERTY_INTEGER                 val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_CUSTOMIND_PROPERTY_STRING                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_DATABASE_EXPORT_FLAGS                      val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_DATABASE_FIELD_TYPE                        val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_DATABASE_IMPORT_FLAGS                      val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_DATABASE_OPEN_FLAGS                        val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_DATABASE_PRINT_FLAGS                       val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_DATATYPE                                   val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_DAY_OF_WEEK                                val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_DEAL_ENTRY                                 val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_DEAL_PROPERTY_DOUBLE                       val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_DEAL_PROPERTY_INTEGER                      val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_DEAL_PROPERTY_STRING                       val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_DEAL_REASON                                val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_DEAL_TYPE                                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_DRAW_TYPE                                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_DX_BUFFER_TYPE                             val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_DX_FORMAT                                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_DX_HANDLE_TYPE                             val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_DX_PRIMITIVE_TOPOLOGY                      val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_DX_SHADER_TYPE                             val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ELLIOT_WAVE_DEGREE                         val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_FILE_POSITION                              val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_FILE_PROPERTY_INTEGER                      val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_FILESELECT_FLAGS                           val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_FP_CLASS                                   val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_GANN_DIRECTION                             val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_GEMM                                       val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_INDEXBUFFER_TYPE                           val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_INDICATOR                                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_INIT_RETCODE                               val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_LICENSE_TYPE                               val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_LINE_STYLE                                 val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_LOSS_FUNCTION                              val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_MA_METHOD                                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_MATRIX_NORM                                val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_MQL_INFO_INTEGER                           val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_MQL_INFO_STRING                            val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_OBJECT                                     val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_OBJECT_PROPERTY_DOUBLE                     val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_OBJECT_PROPERTY_INTEGER                    val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_OBJECT_PROPERTY_STRING                     val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ONNX_TYPE                                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ONNX_DATA_TYPE                             val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ONNX_FLAGS                                 val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_OPENCL_EXECUTION_STATUS                    val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_OPENCL_HANDLE_TYPE                         val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_OPENCL_PROPERTY_INTEGER                    val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_OPENCL_PROPERTY_STRING                     val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ORDER_PROPERTY_DOUBLE                      val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ORDER_PROPERTY_INTEGER                     val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ORDER_PROPERTY_STRING                      val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ORDER_REASON                               val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ORDER_STATE                                val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ORDER_TYPE                                 val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ORDER_TYPE_FILLING                         val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_ORDER_TYPE_TIME                            val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_PLOT_PROPERTY_DOUBLE                       val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_PLOT_PROPERTY_INTEGER                      val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_PLOT_PROPERTY_STRING                       val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_POINTER_TYPE                               val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_POSITION_PROPERTY_DOUBLE                   val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_POSITION_PROPERTY_INTEGER                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_POSITION_PROPERTY_STRING                   val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_POSITION_REASON                            val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_POSITION_TYPE                              val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_PROGRAM_TYPE                               val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_REGRESSION_METRIC                          val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SERIES_INFO_INTEGER                        val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SERIESMODE                                 val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SIGNAL_BASE_DOUBLE                         val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SIGNAL_BASE_INTEGER                        val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SIGNAL_BASE_STRING                         val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SIGNAL_INFO_DOUBLE                         val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SIGNAL_INFO_INTEGER                        val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SIGNAL_INFO_STRING                         val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SORT_MODE                                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_STATISTICS                                 val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_STO_PRICE                                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SYMBOL_CALC_MODE                           val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SYMBOL_CHART_MODE                          val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SYMBOL_INDUSTRY                            val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SYMBOL_INFO_DOUBLE                         val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SYMBOL_INFO_INTEGER                        val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SYMBOL_INFO_STRING                         val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SYMBOL_OPTION_MODE                         val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SYMBOL_OPTION_RIGHT                        val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SYMBOL_ORDER_GTC_MODE                      val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SYMBOL_SECTOR                              val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SYMBOL_SWAP_MODE                           val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SYMBOL_TRADE_EXECUTION                     val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_SYMBOL_TRADE_MODE                          val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_TERMINAL_INFO_DOUBLE                       val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_TERMINAL_INFO_INTEGER                      val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_TERMINAL_INFO_STRING                       val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_TIMEFRAMES                                 val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
        #ifdef __INCLUDE_MQL5_ENUMS__
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_TRADE_REQUEST_ACTIONS                      val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_TRADE_TRANSACTION_TYPE                     val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_VECTOR_CONVOLVE                            val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };
            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, ENUM_VECTOR_NORM                                val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(LIB_DBG_NAMESPACE_DEF(dbg_lib, enum_to_string)(name, val, shift, prefix, offset, hex)); };

        #endif


        // Basic types
                                                                                                                                                                                                                                                                    //  [FORMAT STRING defining output format]                                                                       [prefix]       [Variable name]                                                     [Actual value, additional resolving]                                [HEX or BIT string output, int will try to resolve _LastError variable]
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const char                                   val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(StringFormat("%s[chr]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = %-25hd '%s' (%s)",     prefix,       LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name),     val, ShortToString(val),                                            (hex) ? StringFormat("0x%02hX", (uchar)val)             : LIB_DBG_NAMESPACE(dbg_lib, bits_out)((uchar)val))); }
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const short                                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(StringFormat("%s[shrt] %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = %-25hi '%s' (%s)",     prefix,       LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name),     val, ShortToString(val),                                            (hex) ? StringFormat("0x%04hX", val)                    : LIB_DBG_NAMESPACE(dbg_lib, bits_out)((ushort)val))); }
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const int                                    val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(StringFormat("%s[int]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = %-25i (%s)",           prefix,       LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name),     val,                        (StringFind(name, "_LastError") < 0) ? ((hex) ? StringFormat("0x%08X", val)                     : LIB_DBG_NAMESPACE(dbg_lib, bits_out)((uint)val)) : LIB_DBG_NAMESPACE(dbg_lib, dbg_errcode_to_name)(val) )); }
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const long                                   val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(StringFormat("%s[long] %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = %-25lli (%s)",         prefix,       LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name),     val,                                                                (hex) ? StringFormat("0x%016llX", val)                  : LIB_DBG_NAMESPACE(dbg_lib, bits_out)((ulong)val))); }
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const uchar                                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(StringFormat("%s[uchr] %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = %-25hu '%s' (%s)",     prefix,       LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name),     val, ShortToString(val),                                            (hex) ? StringFormat("0x%02hX", val)                    : LIB_DBG_NAMESPACE(dbg_lib, bits_out)(val))); }
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const ushort                                 val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(StringFormat("%s[usht] %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = %-25hu '%s' (%s)",     prefix,       LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name),     val, ShortToString(val),                                            (hex) ? StringFormat("0x%04hX", val)                    : LIB_DBG_NAMESPACE(dbg_lib, bits_out)(val))); }
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const uint                                   val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(StringFormat("%s[uint] %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = %-25u (%s)",           prefix,       LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name),     val,                                                                (hex) ? StringFormat("0x%08X", val)                     : LIB_DBG_NAMESPACE(dbg_lib, bits_out)(val))); }
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const ulong                                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(StringFormat("%s[ul]   %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = %-25llu (%s)",         prefix,       LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name),     val,                                                                (hex) ? StringFormat("0x%016llX", val)                  : LIB_DBG_NAMESPACE(dbg_lib, bits_out)(val))); }
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const string                                 val,    const int shift = 0, const string   prefix = "",    const int offset = 0)                                       { const string dbg_len = StringFormat("length: %i", StringLen(val));
                                                                                                                                                                                                                                                              return(StringFormat("%s[str]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = '%s' (%s)",            prefix,       LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name),     (val == NULL) ? "NULL" : ((val == "") ? "" : val), dbg_len)); }
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const float                                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(StringFormat("%s[flt]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = %-25s (%s)",           prefix,       LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name),     LIB_DBG_NAMESPACE_DEF(dbg_lib, dbg_ieee754_to_string)(val),         (hex) ? LIB_DBG_NAMESPACE_DEF(dbg_lib, flt_raw)(val)    : LIB_DBG_NAMESPACE(dbg_lib, bits_out)(val))); }
        #ifndef __MQL4__
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const double                                 val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(StringFormat("%s[dbl]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = %-25s (%s)",           prefix,       LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name),     (string)val,                                                        (hex) ? LIB_DBG_NAMESPACE_DEF(dbg_lib, dbl_raw)(val)    : LIB_DBG_NAMESPACE(dbg_lib, bits_out)(val))); }
        #else
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const double                                 val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(StringFormat("%s[dbl]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = %-25s (%s)",           prefix,       LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name),     LIB_DBG_NAMESPACE_DEF(dbg_lib, dbg_ieee754_to_string)(val),         (hex) ? LIB_DBG_NAMESPACE_DEF(dbg_lib, dbl_raw)(val)    : LIB_DBG_NAMESPACE(dbg_lib, bits_out)(val))); }

        #endif
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const color                                  val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(StringFormat("%s[clr]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = %-25s (%s)",           prefix,       LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name),     ColorToString(val, true),                                           (hex) ? StringFormat("0x%08X", val)                     : LIB_DBG_NAMESPACE(dbg_lib, bits_out)((uint)val))); }
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const bool                                   val,    const int shift = 0, const string   prefix = "",    const int offset = 0)                                       { return(StringFormat("%s[bool] %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = %s",                   prefix,       LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name),     (val) ? "true" : "false")); }


        // Datetime added details
                                                                                                                                                                                                                                                                    //  [FORMAT STRING defining output format]                                                                       [prefix]       [Variable name]                                                     [Actual value, additional resolving]
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const datetime                               val,    const int shift = 0, const string   prefix = "",    const int offset = 0, const bool hex = DBG_HEX_OUTPUT)      { return(StringFormat("%s[dtm]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = %s %s %s (%s)",        prefix,       LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name),     (val == NULL) ? "NULL" : ((val < NULL) ? StringFormat("[NEGATIVE VALUE] %lli", val) : ((StringLen(LIB_DBG_NAMESPACE(dbg_lib, dbg_TimeToString)(val)) <= NULL) ? StringFormat("[NON DATE VALUE] %llu", val) : LIB_DBG_NAMESPACE(dbg_lib, dbg_TimeToString)(val))), (val <= NULL) ? "" : LIB_DBG_NAMESPACE(dbg_lib, dbg_day_of_week)(val), (val > NULL) && (val < 31536000) ? StringFormat("(long: %lli)", (long)val) : "", (hex) ? StringFormat("0x%016llX", val) : LIB_DBG_NAMESPACE(dbg_lib, bits_out)((ulong)val))); }


        // Pointers

            template <typename T>                                                                                                                                                                                                                                   //  [FORMAT STRING defining output format]                                                                       [prefix]       [Variable name]                                                     [Detailed pointer information]
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, T*                                           val,    const int shift = 0, const string   prefix = "",    const int offset = 0)                                       { return(StringFormat("%s[ptr]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = '%s'",                 prefix,       LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name),     (val == NULL) ? StringFormat("ptr: NULL (%s)", typename_raw(val)) : ((CheckPointer(val) != POINTER_INVALID) ? typename_raw(val) : StringFormat("POINTER_INVALID (%s)", typename_raw(val))))); }


        // Unknown enumerations and unknown types/objects

            template <typename T>                                                                                                                                                                                                                                   //  [FORMAT STRING defining output format]                                                                       [prefix]       [Enumeration of uncnown object]             [Variable name]         [Unknown type typename]
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, T&                                           val,    const int shift = 0, const string   prefix = "",    const int offset = 0)                                       { const string _name = LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name); string enum_name = "";
                                                                                                                                                                                                                                                              const string type_id = LIB_DBG_NAMESPACE(dbg_lib, eval_unknown_type)(_name, val, enum_name);
                                                                                                                                                                                                                                                              return(StringFormat("%s%s %-"     + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = '%s'",                 prefix,       (type_id == NULL) ? "[obj] " : "[enum]",    _name,                  typename((val)))); };


        // Complex type

        #ifdef LIB_DBG_INCLUDE_COMPLEX_TYPE
        #ifndef __MQL4__
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const complex&                               val,    const int shift = 0, const string   prefix = "",    const int offset = 0)                                       { return(StringFormat("%s[cplx] %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = %-25s %s (r:%s i:%s)", prefix,       LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name),     StringFormat("r:%s", (string)val.real), StringFormat("i:%s", (string)val.imag), LIB_DBG_NAMESPACE_DEF(dbg_lib, dbl_raw)(val.real), LIB_DBG_NAMESPACE_DEF(dbg_lib, dbl_raw)(val.imag))); }

        #else
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const complex&                               val,    const int shift = 0, const string   prefix = "",    const int offset = 0)                                       { return(StringFormat("%s[cplx] %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = %-25s %s (r:%s i:%s)", prefix,       LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name),     StringFormat("r:%s", LIB_DBG_NAMESPACE_DEF(dbg_lib, dbg_ieee754_to_string)(val.real)), StringFormat("i:%s", LIB_DBG_NAMESPACE_DEF(dbg_lib, dbg_ieee754_to_string)(val.imag)), LIB_DBG_NAMESPACE_DEF(dbg_lib, dbl_raw)(val.real), LIB_DBG_NAMESPACE_DEF(dbg_lib, dbl_raw)(val.imag))); }

        #endif
        #endif


        // Arrays

        // Define display list size limit
        #define DBG_ARRAY_DISPLAY_LIST_MAX_LIMIT(_e, _l, _c)     _c = (_e > _l) && (_c >= (_l/2) - 1) && (_c < (_e - (_l/2))) ? _e - ((_l/2) + 1) : _c


            template <typename T>
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const T&                                     val[],  const int shift = 0, const string   prefix = "",    const int offset = 0)
            {
                string _name = LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name); StringReplace(_name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const int elements = ArraySize(val);
                string __out = (elements > NULL) ? StringFormat("[arr]  (Size: %i) = { %s%s%s", elements, ArrayIsDynamic(val) ? " [dynamic]" : " [static]", ArrayGetAsSeries(val) ? " [indexing as series]" : "", ArrayIsSeries(val) ? " [timeseries array]" : "") : StringFormat("[arr]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s %-25s", typename_raw(val), "{ EMPTY_ARRAY");
                const int limit = DBG_MSG_VAR_ARRAY_LIMIT(val);
                for(int cnt = NULL; (cnt < elements) && (!_StopFlag); cnt++)
                { __out += "\n" + _shift + LIB_DBG_NAMESPACE(dbg_lib, var_out)(StringFormat("%s[%i])", _name, cnt), val[cnt], shift, prefix) + "\n"; DBG_ARRAY_DISPLAY_LIST_MAX_LIMIT(elements, limit, cnt); }
                return(__out);
            }

            template <typename T>
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const T&                                   val[][],  const int shift = 0, const string   prefix = "",    const int offset = 0)
            {
                string _name            = LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name); StringReplace(_name, ")", "");
                const string _shift     = StringFormat("%" + IntegerToString(shift) + "s", "");
                const int elements      = ArraySize(val);
                const int elements_d1   = ArrayRange(val, 0);
                const int elements_d2   = ArrayRange(val, 1);
                string __out = (elements > NULL) ? StringFormat("[arr]  (Size: %i) = { %s", elements, ArrayIsDynamic(val) ? " [dynamic]" : " [static]") : StringFormat("[arr]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s %-25s", typename_raw(val), "{ EMPTY_ARRAY");
                const int limit = DBG_MSG_VAR_ARRAY_LIMIT(val);
                for(int cnt_d1 = NULL; (cnt_d1 < elements_d1) && (!_StopFlag); cnt_d1++)
                {
                    cnt_d1 = ((elements_d1 > (limit/2)) && (cnt_d1 > 3) && (cnt_d1 < (elements_d1 - (limit/2)))) ? (elements_d1 - (limit/2)) : cnt_d1;
                    for(int cnt = NULL; (cnt < elements_d2) && (!_StopFlag); cnt++)
                    { __out += "\n" + _shift + LIB_DBG_NAMESPACE(dbg_lib, var_out)(StringFormat("%s[%i][%i])", _name, cnt_d1, cnt), val[cnt_d1][cnt], shift, prefix) + "\n"; DBG_ARRAY_DISPLAY_LIST_MAX_LIMIT(elements_d2, limit, cnt); }
                }
                return(__out);
            }

            template <typename T>
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const T&                                 val[][][],  const int shift = 0, const string   prefix = "",    const int offset = 0)
            {
                string _name            = LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name); StringReplace(_name, ")", "");
                const string _shift     = StringFormat("%" + IntegerToString(shift) + "s", "");
                const int elements      = ArraySize(val);
                const int elements_d1   = ArrayRange(val, 0);
                const int elements_d2   = ArrayRange(val, 1);
                const int elements_d3   = ArrayRange(val, 2);
                string __out = (elements > NULL) ? StringFormat("[arr]  (Size: %i) = { %s", elements, ArrayIsDynamic(val) ? " [dynamic]" : " [static]") : StringFormat("[arr]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s %-25s", typename_raw(val), "{ EMPTY_ARRAY");
                const int limit = DBG_MSG_VAR_ARRAY_LIMIT(val);
                for(int cnt_d1 = NULL; (cnt_d1 < elements_d1) && (!_StopFlag); cnt_d1++)
                {
                    cnt_d1 = ((elements_d1 > (limit/2)) && (cnt_d1 > 3) && (cnt_d1 < (elements_d1 - (limit/2)))) ? (elements_d1 - (limit/2)) : cnt_d1;
                    for(int cnt_d2 = NULL; (cnt_d2 < elements_d2) && (!_StopFlag); cnt_d2++)
                    {
                        cnt_d2 = ((elements_d2 > (limit/2)) && (cnt_d2 > 3) && (cnt_d2 < (elements_d2 - (limit/2)))) ? (elements_d2 - (limit/2)) : cnt_d2;
                        for(int cnt = NULL; (cnt < elements_d3) && (!_StopFlag); cnt++)
                        { __out += "\n" + _shift + LIB_DBG_NAMESPACE(dbg_lib, var_out)(StringFormat("%s[%i][%i][%i])", _name, cnt_d1, cnt_d2, cnt), val[cnt_d1][cnt_d2][cnt], shift, prefix) + "\n"; DBG_ARRAY_DISPLAY_LIST_MAX_LIMIT(elements_d3, limit, cnt); }
                    }
                }
                return(__out);
            }

            template <typename T>
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const T&                               val[][][][],  const int shift = 0, const string   prefix = "",    const int offset = 0)
            {
                string _name            = LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name); StringReplace(_name, ")", "");
                const string _shift     = StringFormat("%" + IntegerToString(shift) + "s", "");
                const int elements      = ArraySize(val);
                const int elements_d1   = ArrayRange(val, 0);
                const int elements_d2   = ArrayRange(val, 1);
                const int elements_d3   = ArrayRange(val, 2);
                const int elements_d4   = ArrayRange(val, 3);
                string __out = (elements > NULL) ? StringFormat("[arr]  (Size: %i) = { %s", elements, ArrayIsDynamic(val) ? " [dynamic]" : " [static]") : StringFormat("[arr]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s %-25s", typename_raw(val), "{ EMPTY_ARRAY");
                const int limit = DBG_MSG_VAR_ARRAY_LIMIT(val);
                for(int cnt_d1 = NULL; (cnt_d1 < elements_d1) && (!_StopFlag); cnt_d1++)
                {
                    cnt_d1 = ((elements_d1 > (limit/2)) && (cnt_d1 > 3) && (cnt_d1 < (elements_d1 - (limit/2)))) ? (elements_d1 - (limit/2)) : cnt_d1;
                    for(int cnt_d2 = NULL; (cnt_d2 < elements_d2) && (!_StopFlag); cnt_d2++)
                    {
                        cnt_d2 = ((elements_d2 > (limit/2)) && (cnt_d2 > 3) && (cnt_d2 < (elements_d2 - (limit/2)))) ? (elements_d2 - (limit/2)) : cnt_d2;
                        for(int cnt_d3 = NULL; (cnt_d3 < elements_d3) && (!_StopFlag); cnt_d3++)
                        {
                            cnt_d3 = ((elements_d3 > (limit/2)) && (cnt_d3 > 3) && (cnt_d3 < (elements_d3 - (limit/2)))) ? (elements_d3 - (limit/2)) : cnt_d3;
                            for(int cnt = NULL; (cnt < elements_d4) && (!_StopFlag); cnt++)
                            { __out += "\n" + _shift + LIB_DBG_NAMESPACE(dbg_lib, var_out)(StringFormat("%s[%i][%i][%i][%i])", _name, cnt_d1, cnt_d2, cnt_d3, cnt), val[cnt_d1][cnt_d2][cnt_d3][cnt], shift, prefix) + "\n"; DBG_ARRAY_DISPLAY_LIST_MAX_LIMIT(elements_d4, limit, cnt); }
                        }
                    }
                }
                return(__out);
            }



            template <typename T>
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, T*&                                          val[],  const int shift = 0, const string   prefix = "",    const int offset = 0)
            {
                string _name = LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name); StringReplace(_name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const int elements = ArraySize(val);
                string __out = (elements > NULL) ? StringFormat("[arr]  (Size: %i) = { %s%s", elements, ArrayIsDynamic(val) ? " [dynamic]" : " [static]", ArrayGetAsSeries(val) ? " [indexing as series]" : "") : StringFormat("[arr]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s %-25s", typename_raw(val), "{ EMPTY_ARRAY");
                const int limit = DBG_MSG_VAR_ARRAY_LIMIT(val);
                for(int cnt = NULL; (cnt < elements) && (!_StopFlag); cnt++)
                { __out += "\n" + _shift + LIB_DBG_NAMESPACE(dbg_lib, var_out)(StringFormat("%s[%i])", _name, cnt), val[cnt], shift, prefix) + "\n"; DBG_ARRAY_DISPLAY_LIST_MAX_LIMIT(elements, limit, cnt); }
                return(__out);
            }

            template <typename T>
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, T*&                                        val[][],  const int shift = 0, const string   prefix = "",    const int offset = 0)
            {
                string _name            = LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name); StringReplace(_name, ")", "");
                const string _shift     = StringFormat("%" + IntegerToString(shift) + "s", "");
                const int elements      = ArraySize(val);
                const int elements_d1   = ArrayRange(val, 0);
                const int elements_d2   = ArrayRange(val, 1);
                string __out = (elements > NULL) ? StringFormat("[arr]  (Size: %i) = { %s", elements, ArrayIsDynamic(val) ? " [dynamic]" : " [static]") : StringFormat("[arr]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s %-25s", typename_raw(val), "{ EMPTY_ARRAY");
                const int limit = DBG_MSG_VAR_ARRAY_LIMIT(val);
                for(int cnt_d1 = NULL; (cnt_d1 < elements_d1) && (!_StopFlag); cnt_d1++)
                {
                    cnt_d1 = ((elements_d1 > (limit/2)) && (cnt_d1 > 3) && (cnt_d1 < (elements_d1 - (limit/2)))) ? (elements_d1 - (limit/2)) : cnt_d1;
                    for(int cnt = NULL; (cnt < elements_d2) && (!_StopFlag); cnt++)
                    { __out += "\n" + _shift + LIB_DBG_NAMESPACE(dbg_lib, var_out)(StringFormat("%s[%i][%i])", _name, cnt_d1, cnt), val[cnt_d1][cnt], shift, prefix) + "\n"; DBG_ARRAY_DISPLAY_LIST_MAX_LIMIT(elements_d2, limit, cnt); }
                }
                return(__out);
            }

            template <typename T>
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, T*&                                      val[][][],  const int shift = 0, const string   prefix = "",    const int offset = 0)
            {
                string _name            = LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name); StringReplace(_name, ")", "");
                const string _shift     = StringFormat("%" + IntegerToString(shift) + "s", "");
                const int elements      = ArraySize(val);
                const int elements_d1   = ArrayRange(val, 0);
                const int elements_d2   = ArrayRange(val, 1);
                const int elements_d3   = ArrayRange(val, 2);
                string __out = (elements > NULL) ? StringFormat("[arr]  (Size: %i) = { %s", elements, ArrayIsDynamic(val) ? " [dynamic]" : " [static]") : StringFormat("[arr]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s %-25s", typename_raw(val), "{ EMPTY_ARRAY");
                const int limit = DBG_MSG_VAR_ARRAY_LIMIT(val);
                for(int cnt_d1 = NULL; (cnt_d1 < elements_d1) && (!_StopFlag); cnt_d1++)
                {
                    cnt_d1 = ((elements_d1 > (limit/2)) && (cnt_d1 > 3) && (cnt_d1 < (elements_d1 - (limit/2)))) ? (elements_d1 - (limit/2)) : cnt_d1;
                    for(int cnt_d2 = NULL; (cnt_d2 < elements_d2) && (!_StopFlag); cnt_d2++)
                    {
                        cnt_d2 = ((elements_d2 > (limit/2)) && (cnt_d2 > 3) && (cnt_d2 < (elements_d2 - (limit/2)))) ? (elements_d2 - (limit/2)) : cnt_d2;
                        for(int cnt = NULL; (cnt < elements_d3) && (!_StopFlag); cnt++)
                        { __out += "\n" + _shift + LIB_DBG_NAMESPACE(dbg_lib, var_out)(StringFormat("%s[%i][%i][%i])", _name, cnt_d1, cnt_d2, cnt), val[cnt_d1][cnt_d2][cnt], shift, prefix) + "\n"; DBG_ARRAY_DISPLAY_LIST_MAX_LIMIT(elements_d3, limit, cnt); }
                    }
                }
                return(__out);
            }

            template <typename T>
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, T*&                                    val[][][][],  const int shift = 0, const string   prefix = "",    const int offset = 0)
            {
                string _name            = LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name); StringReplace(_name, ")", "");
                const string _shift     = StringFormat("%" + IntegerToString(shift) + "s", "");
                const int elements      = ArraySize(val);
                const int elements_d1   = ArrayRange(val, 0);
                const int elements_d2   = ArrayRange(val, 1);
                const int elements_d3   = ArrayRange(val, 2);
                const int elements_d4   = ArrayRange(val, 3);
                string __out = (elements > NULL) ? StringFormat("[arr]  (Size: %i) = { %s", elements, ArrayIsDynamic(val) ? " [dynamic]" : " [static]") : StringFormat("[arr]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s %-25s", typename_raw(val), "{ EMPTY_ARRAY");
                const int limit = DBG_MSG_VAR_ARRAY_LIMIT(val);
                for(int cnt_d1 = NULL; (cnt_d1 < elements_d1) && (!_StopFlag); cnt_d1++)
                {
                    cnt_d1 = ((elements_d1 > (limit/2)) && (cnt_d1 > 3) && (cnt_d1 < (elements_d1 - (limit/2)))) ? (elements_d1 - (limit/2)) : cnt_d1;
                    for(int cnt_d2 = NULL; (cnt_d2 < elements_d2) && (!_StopFlag); cnt_d2++)
                    {
                        cnt_d2 = ((elements_d2 > (limit/2)) && (cnt_d2 > 3) && (cnt_d2 < (elements_d2 - (limit/2)))) ? (elements_d2 - (limit/2)) : cnt_d2;
                        for(int cnt_d3 = NULL; (cnt_d3 < elements_d3) && (!_StopFlag); cnt_d3++)
                        {
                            cnt_d3 = ((elements_d3 > (limit/2)) && (cnt_d3 > 3) && (cnt_d3 < (elements_d3 - (limit/2)))) ? (elements_d3 - (limit/2)) : cnt_d3;
                            for(int cnt = NULL; (cnt < elements_d4) && (!_StopFlag); cnt++)
                            { __out += "\n" + _shift + LIB_DBG_NAMESPACE(dbg_lib, var_out)(StringFormat("%s[%i][%i][%i][%i])", _name, cnt_d1, cnt_d2, cnt_d3, cnt), val[cnt_d1][cnt_d2][cnt_d3][cnt], shift, prefix) + "\n"; DBG_ARRAY_DISPLAY_LIST_MAX_LIMIT(elements_d4, limit, cnt); }
                        }
                    }
                }
                return(__out);
            }

        #undef DBG_ARRAY_DISPLAY_LIST_MAX_LIMIT


        // Vector type

        #ifdef LIB_DBG_INCLUDE_COMPLEX_TYPE
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const vector&                                val,    const int shift = 0, const string   _prefix = "",   const int offset = 0)
            {
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                const ulong v_size = val.Size();
                if(v_size == NULL)
                { return(StringFormat("%s[vct]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = { EMPTY_VECTOR }", prefix, LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name))); }
                string dbg_out = StringFormat("%s\n", LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + "[0]", val[0], NULL, prefix));
                for(ulong cnt = 1; (cnt < v_size); cnt++)
                { dbg_out += StringFormat("%s%s%s\n", _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(StringFormat("%s[%llu]", name, cnt), val[(int)cnt], NULL, prefix), (cnt < v_size - 1) ? "\n" : ""); }
                return(dbg_out); 
            }
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const vectorf&                               val,    const int shift = 0, const string   _prefix = "",   const int offset = 0)
            {
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                const ulong v_size = val.Size();
                if(v_size == NULL)
                { return(StringFormat("%s[vct]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = { EMPTY_VECTOR }", prefix, LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name))); }
                string dbg_out = StringFormat("%s\n", LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + "[0]", val[0], NULL, prefix));
                for(ulong cnt = 1; (cnt < v_size); cnt++) { dbg_out += StringFormat("%s%s%s\n", _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(StringFormat("%s[%llu]", name, cnt), val[(int)cnt], NULL, prefix), (cnt < v_size - 1) ? "\n" : ""); }
                return(dbg_out); 
            }
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const vectorc&                               val,    const int shift = 0, const string   _prefix = "",   const int offset = 0)
            {
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                const ulong v_size = val.Size();
                if(v_size == NULL)
                { return(StringFormat("%s[vct]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = { EMPTY_VECTOR }", prefix, LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name))); }
                string dbg_out = StringFormat("%s\n", LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + "[0]", val[0], NULL, prefix));
                for(ulong cnt = 1; (cnt < v_size); cnt++) { dbg_out += StringFormat("%s%s%s\n", _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(StringFormat("%s[%llu]", name, cnt), val[(int)cnt], NULL, prefix), (cnt < v_size - 1) ? "\n" : ""); }
                return(dbg_out); 
            }

        // Matrix type

            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const matrix&                                val,    const int shift = 0, const string   _prefix = "",   const int offset = 0)
            {
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                const ulong m_rows = val.Rows();
                const ulong m_cols = val.Cols();
                if(val.Rows() + val.Cols() <= NULL)
                { return(StringFormat("%s[mtx]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = { EMPTY_MATRIX }", prefix, LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name))); }
                const int val_out_len = MathMax(StringLen(LIB_DBG_NAMESPACE(dbg_lib, dbg_to_string)(val.Max())), StringLen(LIB_DBG_NAMESPACE(dbg_lib, dbg_to_string)(val.Min())));
                string dbg_out = StringFormat("%s[mtx]  %s =\n", prefix, LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name));
                dbg_out += StringFormat("%" + IntegerToString(StringLen(_shift) + 9 + (long)(log10(m_rows) + 1)) + "s", "");
                for(ulong cnt = NULL; (cnt < m_cols); cnt++)
                { dbg_out += StringFormat("%" + IntegerToString(val_out_len + 2) + "s", StringFormat("[][%i]  ", cnt)); }
                dbg_out += "\n";
                for(ulong row = NULL; (row < m_rows); row++)
                {
                    vector v = val.Row(row);
                    dbg_out += StringFormat("%" + IntegerToString(StringLen(_shift) + 9 + (long)(log10(m_rows) + 1)) + "s", StringFormat("[%i][]: { ", row));
                    for(ulong col = NULL; (col < m_cols); col++)
                    { dbg_out += StringFormat("%" + IntegerToString(val_out_len + ((col < (m_cols - 1)) ? 2 : 0)) + "s", StringFormat("%s", LIB_DBG_NAMESPACE(dbg_lib, dbg_to_string)(v[col]) + ((col < (m_cols - 1)) ? ", " : ""))); }
                    dbg_out += " }" + ((row < (m_rows - 1)) ? ",\n" : "");
                }
                return(dbg_out); 
            }
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const matrixf&                               val,    const int shift = 0, const string   _prefix = "",   const int offset = 0)
            {
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                const ulong m_rows = val.Rows();
                const ulong m_cols = val.Cols();
                if(val.Rows() + val.Cols() <= NULL)
                { return(StringFormat("%s[mtx]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = { EMPTY_MATRIX }", prefix, LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name))); }
                const int val_out_len = MathMax(StringLen(LIB_DBG_NAMESPACE(dbg_lib, dbg_to_string)(val.Max())), StringLen(LIB_DBG_NAMESPACE(dbg_lib, dbg_to_string)(val.Min())));
                string dbg_out = StringFormat("%s[mtx]  %s =\n", prefix, LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name));
                dbg_out += StringFormat("%" + IntegerToString(StringLen(_shift) + 9 + (long)(log10(m_rows) + 1)) + "s", "");
                for(ulong cnt = NULL; (cnt < m_cols); cnt++)
                { dbg_out += StringFormat("%" + IntegerToString(val_out_len + 2) + "s", StringFormat("[][%i]  ", cnt)); }
                dbg_out += "\n";
                for(ulong row = NULL; (row < m_rows); row++)
                {
                    vectorf v = val.Row(row);
                    dbg_out += StringFormat("%" + IntegerToString(StringLen(_shift) + 9 + (long)(log10(m_rows) + 1)) + "s", StringFormat("[%i][]: { ", row));
                    for(ulong col = NULL; (col < m_cols); col++)
                    { dbg_out += StringFormat("%" + IntegerToString(val_out_len + ((col < (m_cols - 1)) ? 2 : 0)) + "s", StringFormat("%s", LIB_DBG_NAMESPACE(dbg_lib, dbg_to_string)(v[col]) + ((col < (m_cols - 1)) ? ", " : ""))); }
                    dbg_out += " }" + ((row < (m_rows - 1)) ? ",\n" : "");
                }
                return(dbg_out); 
            }
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string name, const matrixc&                               val,    const int shift = 0, const string   _prefix = "",   const int offset = 0)
            {
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                const ulong m_rows = val.Rows();
                const ulong m_cols = val.Cols();
                if(val.Rows() + val.Cols() <= NULL)
                { return(StringFormat("%s[mtx]  %-" + IntegerToString(60 - ((offset < 60) ? offset : NULL)) + "s = { EMPTY_MATRIX }", prefix, LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name))); }
                const int val_out_len = StringLen(LIB_DBG_NAMESPACE(dbg_lib, dbg_to_string)(val.Row(0)[0])) + 5;
                string dbg_out = StringFormat("%s[mtx]  %s =\n", prefix, LIB_DBG_NAMESPACE(dbg_lib, dbg_remove_leading_namespace)(name));
                dbg_out += StringFormat("%" + IntegerToString(StringLen(_shift) + 9 + (long)(log10(m_rows) + 1)) + "s", "");
                for(ulong cnt = NULL; (cnt < m_cols); cnt++)
                { dbg_out += StringFormat("%" + IntegerToString(val_out_len + 2) + "s", StringFormat("[][%i]  ", cnt)); }
                dbg_out += "\n";
                for(ulong row = NULL; (row < m_rows); row++)
                {
                    vectorc v = val.Row(row);
                    dbg_out += StringFormat("%" + IntegerToString(StringLen(_shift) + 9 + (long)(log10(m_rows) + 1)) + "s", StringFormat("[%i][]: { ", row));
                    for(ulong col = NULL; (col < m_cols); col++)
                    { dbg_out += StringFormat("%" + IntegerToString(val_out_len + ((col < (m_cols - 1)) ? 2 : 0)) + "s", StringFormat("%s", LIB_DBG_NAMESPACE(dbg_lib, dbg_to_string)(v[col]) + ((col < (m_cols - 1)) ? ", " : ""))); }
                    dbg_out += " }" + ((row < (m_rows - 1)) ? ",\n" : "");
                }
                return(dbg_out); 
            }

        #endif


        // List two arrays side by side

            template <typename T, typename U>
            void LIB_DBG_NAMESPACE_DEF(dbg_lib, list_dump_arrays)(const T& _array1_[], const string _var_name1_, const U& _array2_[], const string _var_name2_, const string _file_, const string _func_, const int _line_, const int limit = NULL)
            {
                const string type1  = typename_raw(_array1_);
                const string type2  = typename_raw(_array2_);
                const int arr1_size = ArraySize(_array1_);
                const int arr2_size = ArraySize(_array2_);
                const int arr_size  = MathMin(arr1_size, arr2_size);

                LIB_DBG_NAMESPACE(dbg_lib, dbg_printf)(LIB_DBG_NAMESPACE(dbg_lib, dbg_context_msg)(DBG_OUTPUT_PREFIX, _file_, _func_, _line_,
                    StringFormat("Vardump list: %s %s[%i] type: %s; %s %s[%i] type: %s", type1, _var_name1_, arr1_size, ((ArrayIsDynamic(_array1_)) ? "dynamic" : "static"), type2, _var_name2_, arr2_size, ((ArrayIsDynamic(_array2_)) ? "dynamic" : "static"))));

                LIB_DBG_NAMESPACE(dbg_lib, dbg_printf)(LIB_DBG_NAMESPACE(dbg_lib, dbg_context_msg)(DBG_OUTPUT_PREFIX + DBG_OUTPUT_PREFIX, _file_, _func_, _line_, StringFormat("%36s[]%28s[]", _var_name1_, _var_name2_)));
                if( (limit == NULL) || (limit >= arr_size))
                {
                    for(int cnt = 0x00; cnt < arr_size; cnt++)
                    {
                        LIB_DBG_NAMESPACE(dbg_lib, dbg_printf)(LIB_DBG_NAMESPACE(dbg_lib, dbg_context_msg)(DBG_OUTPUT_PREFIX + DBG_OUTPUT_PREFIX, _file_, _func_, _line_,
                            StringFormat("[%i] >>> %30s%30s", cnt, LIB_DBG_NAMESPACE(dbg_lib, dbg_to_string)(_array1_[cnt]), LIB_DBG_NAMESPACE(dbg_lib, dbg_to_string)(_array2_[cnt]))));
                    }
                }
                else
                {
                    for(int cnt = 0x00; cnt < limit; cnt++)
                    {
                        LIB_DBG_NAMESPACE(dbg_lib, dbg_printf)(LIB_DBG_NAMESPACE(dbg_lib, dbg_context_msg)(DBG_OUTPUT_PREFIX + DBG_OUTPUT_PREFIX, _file_, _func_, _line_,
                            StringFormat("[%i] >>> %30s%30s", cnt, LIB_DBG_NAMESPACE(dbg_lib, dbg_to_string)(_array1_[cnt]), LIB_DBG_NAMESPACE(dbg_lib, dbg_to_string)(_array2_[cnt]))));
                    }
                    LIB_DBG_NAMESPACE(dbg_lib, dbg_printf)(LIB_DBG_NAMESPACE(dbg_lib, dbg_context_msg)(DBG_OUTPUT_PREFIX + DBG_OUTPUT_PREFIX, _file_, _func_, _line_, StringFormat("%s'%s[]; %s[]' [%i - %i] ... SKIPPED ...", DBG_OUTPUT_PREFIX, _var_name1_, _var_name2_, limit, arr_size - limit - 1)));
                    LIB_DBG_NAMESPACE(dbg_lib, dbg_printf)(LIB_DBG_NAMESPACE(dbg_lib, dbg_context_msg)(DBG_OUTPUT_PREFIX + DBG_OUTPUT_PREFIX, _file_, _func_, _line_, StringFormat("%36s[]%28s[]", _var_name1_, _var_name2_)));
                    for(int cnt = arr_size - limit; cnt < arr_size; cnt++)
                    {
                        LIB_DBG_NAMESPACE(dbg_lib, dbg_printf)(LIB_DBG_NAMESPACE(dbg_lib, dbg_context_msg)(DBG_OUTPUT_PREFIX + DBG_OUTPUT_PREFIX, _file_, _func_, _line_,
                            StringFormat("[%i] >>> %30s%30s", cnt, LIB_DBG_NAMESPACE(dbg_lib, dbg_to_string)(_array1_[cnt]), LIB_DBG_NAMESPACE(dbg_lib, dbg_to_string)(_array2_[cnt]))));
                    }
                }
                if(!_DEBUG)
                {
                    LIB_DBG_NAMESPACE(dbg_lib, dbg_printf)(LIB_DBG_NAMESPACE(dbg_lib, dbg_context_msg)(DBG_OUTPUT_PREFIX, _file_, _func_, _line_,
                        StringFormat("Vardump: [%s] %s[%i] -> [%s] %s[%i] done. Execution delayed for %i seconds.", type1, _var_name1_, arr1_size, type2, _var_name2_, arr2_size, DBG_VARDUMP_PAUSE) ));
                    DBG_SLEEP_SECONDS(DBG_VARDUMP_PAUSE);
                }
                else
                {
                    LIB_DBG_NAMESPACE(dbg_lib, dbg_printf)(LIB_DBG_NAMESPACE(dbg_lib, dbg_context_msg)(DBG_OUTPUT_PREFIX, _file_, _func_, _line_,
                        StringFormat("Vardump: [%s] %s[%i] -> [%s] %s[%i] done.", type1, _var_name1_, arr1_size, type2, _var_name2_, arr2_size) ));
                }
                return;
            }


        // Mql data structures

            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string _name, const MqlDateTime&                          val,    const int shift = 0, const string   _prefix = "",   const int offset = 0)
            {
                string name = " " + _name;
                StringReplace(name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                return(StringFormat("{ Bytes = %i\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".year)",                val.year,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".mon)",                 val.mon,                NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".day)",                 val.day,                NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".hour)",                val.hour,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".min)",                 val.min,                NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".sec)",                 val.sec,                NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".day_of_week)",         val.day_of_week,        NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".day_of_year)",         val.day_of_year,        NULL, prefix)
                        ));
            };
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string _name, const MqlRates&                             val,    const int shift = 0, const string   _prefix = "",   const int offset = 0)
            {
                string name = " " + _name;
                StringReplace(name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                return(StringFormat("{ Bytes = %i\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".time)",                 val.time,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".open)",                 val.open,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".high)",                 val.high,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".low)",                  val.low,                NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".close)",                val.close,              NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".tick_volume)",          val.tick_volume,        NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".spread)",               val.spread,             NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".real_volume)",          val.real_volume,        NULL, prefix)
                        ));
            };
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string _name, const MqlTick&                              val,    const int shift = 0, const string   _prefix = "",   const int offset = 0)
            {
                string name = " " + _name;
                StringReplace(name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                return(
                    #ifdef __INCLUDE_MQL5_DATATYPES__
                        StringFormat("{ Bytes = %i\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s", sizeof(val),

                    #else
                        StringFormat("{ Bytes = %i\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s", sizeof(val),

                    #endif
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".time)",                val.time,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".bid)",                 val.bid,                NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".ask)",                 val.ask,                NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".last)",                val.last,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".volume)",              val.volume,             NULL, prefix)
                    #ifdef __INCLUDE_MQL5_DATATYPES__
                      , _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".time_msc)",  (datetime)val.time_msc,           NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".flags)",        (uchar)val.flags,              NULL, prefix, NULL, false),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".volume_real)",         val.volume_real,        NULL, prefix)

                    #endif
                        ));
            };
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string _name, const MqlParam&                             val, const int shift = 0, const string      _prefix = "",   const int offset = 0)
            {
                string name = " " + _name;
                StringReplace(name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                return(StringFormat("{ Bytes = %i\n%s%s\n%s%s\n%s%s\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".type)",                val.type,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".integer_value)",       val.integer_value,      NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".double_value)",        val.double_value,       NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".string_value)",        val.string_value,       NULL, prefix)
                        ));
            };
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string _name, const MqlBookInfo&                          val, const int shift = 0, const string      _prefix = "",   const int offset = 0)
            {
                string name = " " + _name;
                StringReplace(name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
            #ifndef __MQL4__
                return(StringFormat("{ Bytes = %i\n%s%s\n%s%s\n%s%s\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".type",                 val.type,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".price",                val.price,              NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".volume",               val.volume,             NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".volume_real",          val.volume_real,        NULL, prefix)
                        ));

            #else
                return(StringFormat("{ Bytes = %i\n%s%s\n%s%s\n%s%s\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".type",           (uint)val.type,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".price",                val.price,              NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".volume",               val.volume,             NULL, prefix)
                        ));

            #endif
            };
        #ifdef __INCLUDE_MQL5_DATATYPES__
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string _name, const MqlTradeRequest&                      val, const int shift = 0, const string      _prefix = "",   const int offset = 0)
            {
                string name = " " + _name;
                StringReplace(name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                return(StringFormat("{ Bytes = %i\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".action)",              val.action,             NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".magic)",               val.magic,              NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".order)",               val.order,              NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".symbol)",              val.symbol,             NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".volume)",              val.volume,             NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".price)",               val.price,              NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".stoplimit)",           val.stoplimit,          NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".sl)",                  val.sl,                 NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".tp)",                  val.tp,                 NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".deviation)",           val.deviation,          NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".type)",                val.type,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".type_filling)",        val.type_filling,       NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".type_time)",           val.type_time,          NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".expiration)",          val.expiration,         NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".comment)",             val.comment,            NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".position)",            val.position,           NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".position_by)",         val.position_by,        NULL, prefix)
                        ));
            };
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string _name, const MqlTradeCheckResult&                  val, const int shift = 0, const string      _prefix = "",   const int offset = 0)
            {
                string name = " " + _name;
                StringReplace(name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                return(StringFormat("{ Bytes = %i\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".retcode)",             val.retcode,            NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".balance)",             val.balance,            NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".equity)",              val.equity,             NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".profit)",              val.profit,             NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".margin)",              val.margin,             NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".margin_free)",         val.margin_free,        NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".margin_level)",        val.margin_level,       NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".comment)",             val.comment,            NULL, prefix)
                        ));
            };
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string _name, const MqlTradeResult&                       val, const int shift = 0, const string      _prefix = "",   const int offset = 0)
            {
                string name = " " + _name;
                StringReplace(name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                return(StringFormat("{ Bytes = %i\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".retcode)",             val.retcode,            NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".deal)",                val.deal,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".order)",               val.order,              NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".volume)",              val.volume,             NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".price)",               val.price,              NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".bid)",                 val.bid,                NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".ask)",                 val.ask,                NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".comment)",             val.comment,            NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".request_id)",          val.request_id,         NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".retcode_external)",    val.retcode_external,   NULL, prefix)
                        ));
            };
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string _name, const MqlTradeTransaction&                  val, const int shift = 0, const string      _prefix = "",   const int offset = 0)
            {
                string name = " " + _name;
                StringReplace(name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                return(StringFormat("{ Bytes = %i\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".deal)",                val.deal,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".order)",               val.order,              NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".symbol)",              val.symbol,             NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".type)",                val.type,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".order_type)",          val.order_type,         NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".order_state)",         val.order_state,        NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".deal_type)",           val.deal_type,          NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".time_type)",           val.time_type,          NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".time_expiration)",     val.time_expiration,    NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".price)",               val.price,              NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".price_trigger)",       val.price_trigger,      NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".price_sl)",            val.price_sl,           NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".price_tp)",            val.price_tp,           NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".volume)",              val.volume,             NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".position)",            val.position,           NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".position_by)",         val.position_by,        NULL, prefix)
                        ));
            };
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string _name, const MqlCalendarCountry&                   val, const int shift = 0, const string      _prefix = "",   const int offset = 0)
            {
                string name = " " + _name;
                StringReplace(name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                return(StringFormat("{ Bytes = %i\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".id)",                  val.id,                 NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".name)",                val.name,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".code)",                val.code,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".currency)",            val.currency,           NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".currency_symbol)",     val.currency_symbol,    NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".url_name)",            val.url_name,           NULL, prefix)
                        ));
            };
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string _name, const MqlCalendarEvent&                     val, const int shift = 0, const string      _prefix = "",   const int offset = 0)
            {
                string name = " " + _name;
                StringReplace(name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                return(StringFormat("{ Bytes = %i\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".id)",                  val.id,                 NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".type)",                val.type,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".sector)",              val.sector,             NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".frequency)",           val.frequency,          NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".time_mode)",           val.time_mode,          NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".country_id)",          val.country_id,         NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".unit)",                val.unit,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".importance)",          val.importance,         NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".multiplier)",          val.multiplier,         NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".digits)",              val.digits,             NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".source_url)",          val.source_url,         NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".event_code)",          val.event_code,         NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".url_name)",            val.name,               NULL, prefix)
                        ));
            };
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string _name, const MqlCalendarValue&                     val, const int shift = 0, const string      _prefix = "",   const int offset = 0)
            {
                string name = " " + _name;
                StringReplace(name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                return(StringFormat("{ Bytes = %i\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".id)",                  val.id,                 NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".event_id)",            val.event_id,           NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".time)",                val.time,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".period)",              val.period,             NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".revision)",            val.revision,           NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".actual_value)",        val.actual_value,       NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".prev_value)",          val.prev_value,         NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".revised_prev_value)",  val.revised_prev_value, NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".forecast_value)",      val.forecast_value,     NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".impact_type)",         val.impact_type,        NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".HasActualValue)",      val.HasActualValue(),   NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".HasPreviousValue)",    val.HasPreviousValue(), NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".HasRevisedValue)",     val.HasRevisedValue(),  NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".HasForecastValue)",    val.HasForecastValue(), NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".GetActualValue)",      val.GetActualValue(),   NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".GetPreviousValue)",    val.GetPreviousValue(), NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".GetRevisedValue)",     val.GetRevisedValue(),  NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".GetForecastValue)",    val.GetForecastValue(), NULL, prefix)
                        ));
            };
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string _name, const DXVector&                             val, const int shift = 0, const string      _prefix = "",   const int offset = 0)
            {
                string name = " " + _name;
                StringReplace(name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                return(StringFormat("{ Bytes = %i\n%s%s\n%s%s\n%s%s\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".x)",                   val.x,                  NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".y)",                   val.y,                  NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".z)",                   val.z,                  NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".w)",                   val.w,                  NULL, prefix)
                        ));
            };
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string _name, const DXVertexLayout&                       val, const int shift = 0, const string      _prefix = "",   const int offset = 0)
            {
                string name = " " + _name;
                StringReplace(name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                return(StringFormat("{ Bytes = %i\n%s%s\n%s%s\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".semantic_name)",       val.semantic_name,      NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".semantic_index)",      val.semantic_index,     NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".format)",              val.format,             NULL, prefix)
                        ));
            };



            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string _name, const OnnxTypeInfo&                         val, const int shift = 0, const string      _prefix = "",   const int offset = 0)
            {
                string name = " " + _name;
                StringReplace(name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                return((val.type == ONNX_TYPE_UNKNOWN) ? StringFormat("{ Bytes = %i\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".type)",                val.type,               NULL, prefix)) : 
                        StringFormat("{ Bytes = %i\n%s%s\n%s%s\n%s%s\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".type)",                val.type,               NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".tensor)",              val.tensor,             NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".map)",                 val.map,                NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".sequence)",            val.sequence,           NULL, prefix)
                        ));
            };
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string _name, const OnnxTensorTypeInfo&                   val, const int shift = 0, const string      _prefix = "",   const int offset = 0)
            {
                string name = " " + _name;
                StringReplace(name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                return((val.data_type == ONNX_DATA_TYPE_UNDEFINED) ? StringFormat("{ Bytes = %i\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".data_type)",           val.data_type,          NULL, prefix)) :
                        StringFormat("{ Bytes = %i\n%s%s\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".data_type)",           val.data_type,          NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".dimensions[])",        val.dimensions,         NULL, prefix)
                        ));
            };
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string _name, const OnnxMapTypeInfo&                      val, const int shift = 0, const string      _prefix = "",   const int offset = 0)
            {
                string name = " " + _name;
                StringReplace(name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                return((val.key_type == ONNX_DATA_TYPE_UNDEFINED) ? StringFormat("{ Bytes = %i\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".key_type)",            val.key_type,           NULL, prefix)) :
                        StringFormat("{ Bytes = %i\n%s%s\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".key_type)",            val.key_type,           NULL, prefix),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".value_type)",          val.value_type,         NULL, prefix)
                        ));
            };
            const string    LIB_DBG_NAMESPACE_DEF(dbg_lib, var_out)(const string _name, const OnnxSequenceTypeInfo&                 val, const int shift = 0, const string      _prefix = "",   const int offset = 0)
            {
                string name = " " + _name;
                StringReplace(name, ")", "");
                const string _shift = StringFormat("%" + IntegerToString(shift) + "s", "");
                const string prefix = (_prefix == "") ? StringFormat("{ %s }", typename_raw(val)) : _prefix;
                return((val.value_type.type == ONNX_TYPE_UNKNOWN) ? StringFormat("{ Bytes = %i\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".value_type.type)",     val.value_type.type,    NULL, prefix)) :
                        StringFormat("{ Bytes = %i\n%s%s", sizeof(val),
                        _shift, LIB_DBG_NAMESPACE(dbg_lib, var_out)(name + ".value_type)",          val.value_type,         NULL, prefix)
                        ));
            };


        #endif


        // MQL Error codes to string

            const string LIB_DBG_NAMESPACE_DEF(dbg_lib, dbg_errcode_to_name)(const int err_no, const bool add_user_code_no = false)
            {
                switch(err_no)
                {
                #ifndef __MQL4__
                    // General

                        case 0:      return("ERR_SUCCESS");
                        case 4001:   return("ERR_INTERNAL_ERROR");
                        case 4002:   return("ERR_WRONG_INTERNAL_PARAMETER");
                        case 4003:   return("ERR_INVALID_PARAMETER");
                        case 4004:   return("ERR_NOT_ENOUGH_MEMORY");
                        case 4005:   return("ERR_STRUCT_WITHOBJECTS_ORCLASS");
                        case 4006:   return("ERR_INVALID_ARRAY");
                        case 4007:   return("ERR_ARRAY_RESIZE_ERROR");
                        case 4008:   return("ERR_STRING_RESIZE_ERROR");
                        case 4009:   return("ERR_NOTINITIALIZED_STRING");
                        case 4010:   return("ERR_INVALID_DATETIME");
                        case 4011:   return("ERR_ARRAY_BAD_SIZE");
                        case 4012:   return("ERR_INVALID_POINTER");
                        case 4013:   return("ERR_INVALID_POINTER_TYPE");
                        case 4014:   return("ERR_FUNCTION_NOT_ALLOWED");
                        case 4015:   return("ERR_RESOURCE_NAME_DUPLICATED");
                        case 4016:   return("ERR_RESOURCE_NOT_FOUND");
                        case 4017:   return("ERR_RESOURCE_UNSUPPORTED_TYPE");
                        case 4018:   return("ERR_RESOURCE_NAME_IS_TOO_LONG");
                        case 4019:   return("ERR_MATH_OVERFLOW");
                        case 4020:   return("ERR_SLEEP_ERROR");
                        case 4022:   return("ERR_PROGRAM_STOPPED");


                    // Charts

                        case 4101:   return("ERR_CHART_WRONG_ID");
                        case 4102:   return("ERR_CHART_NO_REPLY");
                        case 4103:   return("ERR_CHART_NOT_FOUND");
                        case 4104:   return("ERR_CHART_NO_EXPERT");
                        case 4105:   return("ERR_CHART_CANNOT_OPEN");
                        case 4106:   return("ERR_CHART_CANNOT_CHANGE");
                        case 4107:   return("ERR_CHART_WRONG_PARAMETER");
                        case 4108:   return("ERR_CHART_CANNOT_CREATE_TIMER");
                        case 4109:   return("ERR_CHART_WRONG_PROPERTY");
                        case 4110:   return("ERR_CHART_SCREENSHOT_FAILED");
                        case 4111:   return("ERR_CHART_NAVIGATE_FAILED");
                        case 4112:   return("ERR_CHART_TEMPLATE_FAILED");
                        case 4113:   return("ERR_CHART_WINDOW_NOT_FOUND");
                        case 4114:   return("ERR_CHART_INDICATOR_CANNOT_ADD");
                        case 4115:   return("ERR_CHART_INDICATOR_CANNOT_DEL");
                        case 4116:   return("ERR_CHART_INDICATOR_NOT_FOUND");


                    // Graphical Objects

                        case 4201:   return("ERR_OBJECT_ERROR");
                        case 4202:   return("ERR_OBJECT_NOT_FOUND");
                        case 4203:   return("ERR_OBJECT_WRONG_PROPERTY");
                        case 4204:   return("ERR_OBJECT_GETDATE_FAILED");
                        case 4205:   return("ERR_OBJECT_GETVALUE_FAILED");


                    // MarketInfo

                        case 4301:   return("ERR_MARKET_UNKNOWN_SYMBOL");
                        case 4302:   return("ERR_MARKET_NOT_SELECTED");
                        case 4303:   return("ERR_MARKET_WRONG_PROPERTY");
                        case 4304:   return("ERR_MARKET_LASTTIME_UNKNOWN");
                        case 4305:   return("ERR_MARKET_SELECT_ERROR");


                    // History Access

                        case 4401:   return("ERR_HISTORY_NOT_FOUND");
                        case 4402:   return("ERR_HISTORY_WRONG_PROPERTY");
                        case 4403:   return("ERR_HISTORY_TIMEOUT");
                        case 4404:   return("ERR_HISTORY_BARS_LIMIT");
                        case 4405:   return("ERR_HISTORY_LOAD_ERRORS");
                        case 4407:   return("ERR_HISTORY_SMALL_BUFFER");


                    // Global_Variables

                        case 4501:   return("ERR_GLOBALVARIABLE_NOT_FOUND");
                        case 4502:   return("ERR_GLOBALVARIABLE_EXISTS");
                        case 4503:   return("ERR_GLOBALVARIABLE_NOT_MODIFIED");
                        case 4504:   return("ERR_GLOBALVARIABLE_CANNOTREAD");
                        case 4505:   return("ERR_GLOBALVARIABLE_CANNOTWRITE");
                        case 4510:   return("ERR_MAIL_SEND_FAILED");
                        case 4511:   return("ERR_PLAY_SOUND_FAILED");
                        case 4512:   return("ERR_MQL5_WRONG_PROPERTY");
                        case 4513:   return("ERR_TERMINAL_WRONG_PROPERTY");
                        case 4514:   return("ERR_FTP_SEND_FAILED");
                        case 4515:   return("ERR_NOTIFICATION_SEND_FAILED");
                        case 4516:   return("ERR_NOTIFICATION_WRONG_PARAMETER");
                        case 4517:   return("ERR_NOTIFICATION_WRONG_SETTINGS");
                        case 4518:   return("ERR_NOTIFICATION_TOO_FREQUENT");
                        case 4519:   return("ERR_FTP_NOSERVER");
                        case 4520:   return("ERR_FTP_NOLOGIN");
                        case 4521:   return("ERR_FTP_FILE_ERROR");
                        case 4522:   return("ERR_FTP_CONNECT_FAILED");
                        case 4523:   return("ERR_FTP_CHANGEDIR");
                        case 4524: //return("ERR_FTP_CLOSED");


                    // Custom Indicator Buffers

                        case 4601:   return("ERR_BUFFERS_NO_MEMORY");
                        case 4602:   return("ERR_BUFFERS_WRONG_INDEX");


                    // Custom Indicator Properties

                        case 4603:   return("ERR_CUSTOM_WRONG_PROPERTY");


                    // Account

                        case 4701:   return("ERR_ACCOUNT_WRONG_PROPERTY");
                        case 4751:   return("ERR_TRADE_WRONG_PROPERTY");
                        case 4752:   return("ERR_TRADE_DISABLED");
                        case 4753:   return("ERR_TRADE_POSITION_NOT_FOUND");
                        case 4754:   return("ERR_TRADE_ORDER_NOT_FOUND");
                        case 4755:   return("ERR_TRADE_DEAL_NOT_FOUND");
                        case 4756:   return("ERR_TRADE_SEND_FAILED");
                        case 4758:   return("ERR_TRADE_CALC_FAILED");


                    // Indicators

                        case 4801:   return("ERR_INDICATOR_UNKNOWN_SYMBOL");
                        case 4802:   return("ERR_INDICATOR_CANNOT_CREATE");
                        case 4803:   return("ERR_INDICATOR_NO_MEMORY");
                        case 4804:   return("ERR_INDICATOR_CANNOT_APPLY");
                        case 4805:   return("ERR_INDICATOR_CANNOT_ADD");
                        case 4806:   return("ERR_INDICATOR_DATA_NOT_FOUND");
                        case 4807:   return("ERR_INDICATOR_WRONG_HANDLE");
                        case 4808:   return("ERR_INDICATOR_WRONG_PARAMETERS");
                        case 4809:   return("ERR_INDICATOR_PARAMETERS_MISSING");
                        case 4810:   return("ERR_INDICATOR_CUSTOM_NAME");
                        case 4811:   return("ERR_INDICATOR_PARAMETER_TYPE");
                        case 4812:   return("ERR_INDICATOR_WRONG_INDEX");


                    // Depth of Market

                        case 4901:   return("ERR_BOOKS_CANNOT_ADD");
                        case 4902:   return("ERR_BOOKS_CANNOT_DELETE");
                        case 4903:   return("ERR_BOOKS_CANNOT_GET");
                        case 4904:   return("ERR_BOOKS_CANNOT_SUBSCRIBE");


                    // File Operations

                        case 5001:   return("ERR_TOO_MANY_FILES");
                        case 5002:   return("ERR_WRONG_FILENAME");
                        case 5003:   return("ERR_TOO_LONG_FILENAME");
                        case 5004:   return("ERR_CANNOT_OPEN_FILE");
                        case 5005:   return("ERR_FILE_CACHEBUFFER_ERROR");
                        case 5006:   return("ERR_CANNOT_DELETE_FILE");
                        case 5007:   return("ERR_INVALID_FILEHANDLE");
                        case 5008:   return("ERR_WRONG_FILEHANDLE");
                        case 5009:   return("ERR_FILE_NOTTOWRITE");
                        case 5010:   return("ERR_FILE_NOTTOREAD");
                        case 5011:   return("ERR_FILE_NOTBIN");
                        case 5012:   return("ERR_FILE_NOTTXT");
                        case 5013:   return("ERR_FILE_NOTTXTORCSV");
                        case 5014:   return("ERR_FILE_NOTCSV");
                        case 5015:   return("ERR_FILE_READERROR");
                        case 5016:   return("ERR_FILE_BINSTRINGSIZE");
                        case 5017:   return("ERR_INCOMPATIBLE_FILE");
                        case 5018:   return("ERR_FILE_IS_DIRECTORY");
                        case 5019:   return("ERR_FILE_NOT_EXIST");
                        case 5020:   return("ERR_FILE_CANNOT_REWRITE");
                        case 5021:   return("ERR_WRONG_DIRECTORYNAME");
                        case 5022:   return("ERR_DIRECTORY_NOT_EXIST");
                        case 5023:   return("ERR_FILE_ISNOT_DIRECTORY");
                        case 5024:   return("ERR_CANNOT_DELETE_DIRECTORY");
                        case 5025:   return("ERR_CANNOT_CLEAN_DIRECTORY");
                        case 5026:   return("ERR_FILE_WRITEERROR");
                        case 5027:   return("ERR_FILE_ENDOFFILE");


                    // String Casting

                        case 5030:   return("ERR_NO_STRING_DATE");
                        case 5031:   return("ERR_WRONG_STRING_DATE");
                        case 5032:   return("ERR_WRONG_STRING_TIME");
                        case 5033:   return("ERR_STRING_TIME_ERROR");
                        case 5034:   return("ERR_STRING_OUT_OF_MEMORY");
                        case 5035:   return("ERR_STRING_SMALL_LEN");
                        case 5036:   return("ERR_STRING_TOO_BIGNUMBER");
                        case 5037:   return("ERR_WRONG_FORMATSTRING");
                        case 5038:   return("ERR_TOO_MANY_FORMATTERS");
                        case 5039:   return("ERR_TOO_MANY_PARAMETERS");
                        case 5040:   return("ERR_WRONG_STRING_PARAMETER");
                        case 5041:   return("ERR_STRINGPOS_OUTOFRANGE");
                        case 5042:   return("ERR_STRING_ZEROADDED");
                        case 5043:   return("ERR_STRING_UNKNOWNTYPE");
                        case 5044:   return("ERR_WRONG_STRING_OBJECT");


                    // Operations with Arrays

                        case 5050:   return("ERR_INCOMPATIBLE_ARRAYS");
                        case 5051:   return("ERR_SMALL_ASSERIES_ARRAY");
                        case 5052:   return("ERR_SMALL_ARRAY");
                        case 5053:   return("ERR_ZEROSIZE_ARRAY");
                        case 5054:   return("ERR_NUMBER_ARRAYS_ONLY");
                        case 5055:   return("ERR_ONEDIM_ARRAYS_ONLY");
                        case 5056:   return("ERR_SERIES_ARRAY");
                        case 5057:   return("ERR_DOUBLE_ARRAY_ONLY");
                        case 5058:   return("ERR_FLOAT_ARRAY_ONLY");
                        case 5059:   return("ERR_LONG_ARRAY_ONLY");
                        case 5060:   return("ERR_INT_ARRAY_ONLY");
                        case 5061:   return("ERR_SHORT_ARRAY_ONLY");
                        case 5062:   return("ERR_CHAR_ARRAY_ONLY");
                        case 5063:   return("ERR_STRING_ARRAY_ONLY");


                    // Operations with OpenCL

                        case 5100:   return("ERR_OPENCL_NOT_SUPPORTED");
                        case 5101:   return("ERR_OPENCL_INTERNAL");
                        case 5102:   return("ERR_OPENCL_INVALID_HANDLE");
                        case 5103:   return("ERR_OPENCL_CONTEXT_CREATE");
                        case 5104:   return("ERR_OPENCL_QUEUE_CREATE");
                        case 5105:   return("ERR_OPENCL_PROGRAM_CREATE");
                        case 5106:   return("ERR_OPENCL_TOO_LONG_KERNEL_NAME");
                        case 5107:   return("ERR_OPENCL_KERNEL_CREATE");
                        case 5108:   return("ERR_OPENCL_SET_KERNEL_PARAMETER");
                        case 5109:   return("ERR_OPENCL_EXECUTE");
                        case 5110:   return("ERR_OPENCL_WRONG_BUFFER_SIZE");
                        case 5111:   return("ERR_OPENCL_WRONG_BUFFER_OFFSET");
                        case 5112:   return("ERR_OPENCL_BUFFER_CREATE");
                        case 5113:   return("ERR_OPENCL_TOO_MANY_OBJECTS");
                        case 5114:   return("ERR_OPENCL_SELECTDEVICE");


                    // Operations with Databases

                        case 5120:   return("ERR_DATABASE_INTERNAL");
                        case 5121:   return("ERR_DATABASE_INVALID_HANDLE");
                        case 5122:   return("ERR_DATABASE_TOO_MANY_OBJECTS");
                        case 5123:   return("ERR_DATABASE_CONNECT");
                        case 5124:   return("ERR_DATABASE_EXECUTE");
                        case 5125:   return("ERR_DATABASE_PREPARE");
                        case 5126:   return("ERR_DATABASE_NO_MORE_DATA");
                        case 5127:   return("ERR_DATABASE_STEP");
                        case 5128:   return("ERR_DATABASE_NOT_READY");
                        case 5129:   return("ERR_DATABASE_BIND_PARAMETERS");


                    // Operations with WebRequest

                        case 5200:   return("ERR_WEBREQUEST_INVALID_ADDRESS");
                        case 5201:   return("ERR_WEBREQUEST_CONNECT_FAILED");
                        case 5202:   return("ERR_WEBREQUEST_TIMEOUT");
                        case 5203:   return("ERR_WEBREQUEST_REQUEST_FAILED");


                    // Operations with Network Sockets

                        case 5270:   return("ERR_NETSOCKET_INVALIDHANDLE");
                        case 5271:   return("ERR_NETSOCKET_TOO_MANY_OPENED");
                        case 5272:   return("ERR_NETSOCKET_CANNOT_CONNECT");
                        case 5273:   return("ERR_NETSOCKET_IO_ERROR");
                        case 5274:   return("ERR_NETSOCKET_HANDSHAKE_FAILED");
                        case 5275:   return("ERR_NETSOCKET_NO_CERTIFICATE");


                    // Custom Symbols

                        case 5300:   return("ERR_NOT_CUSTOM_SYMBOL");
                        case 5301:   return("ERR_CUSTOM_SYMBOL_WRONG_NAME");
                        case 5302:   return("ERR_CUSTOM_SYMBOL_NAME_LONG");
                        case 5303:   return("ERR_CUSTOM_SYMBOL_PATH_LONG");
                        case 5304:   return("ERR_CUSTOM_SYMBOL_EXIST");
                        case 5305:   return("ERR_CUSTOM_SYMBOL_ERROR");
                        case 5306:   return("ERR_CUSTOM_SYMBOL_SELECTED");
                        case 5307:   return("ERR_CUSTOM_SYMBOL_PROPERTY_WRONG");
                        case 5308:   return("ERR_CUSTOM_SYMBOL_PARAMETER_ERROR");
                        case 5309:   return("ERR_CUSTOM_SYMBOL_PARAMETER_LONG");
                        case 5310:   return("ERR_CUSTOM_TICKS_WRONG_ORDER");


                    // Economics calendar

                        case 5400:   return("ERR_CALENDAR_MORE_DATA");
                        case 5401:   return("ERR_CALENDAR_TIMEOUT");
                        case 5402:   return("ERR_CALENDAR_NO_DATA");


                    // Working with Databases

                        case 5601:   return("ERR_DATABASE_ERROR");
                        case 5602:   return("ERR_DATABASE_LOGIC");
                        case 5603:   return("ERR_DATABASE_PERM");
                        case 5604:   return("ERR_DATABASE_ABORT");
                        case 5605:   return("ERR_DATABASE_BUSY");
                        case 5606:   return("ERR_DATABASE_LOCKED");
                        case 5607:   return("ERR_DATABASE_NOMEM");
                        case 5608:   return("ERR_DATABASE_READONLY");
                        case 5609:   return("ERR_DATABASE_INTERRUPT");
                        case 5610:   return("ERR_DATABASE_IOERR");
                        case 5611:   return("ERR_DATABASE_CORRUPT");
                        case 5612:   return("ERR_DATABASE_NOTFOUND");
                        case 5613:   return("ERR_DATABASE_FULL");
                        case 5614:   return("ERR_DATABASE_CANTOPEN");
                        case 5615:   return("ERR_DATABASE_PROTOCOL");
                        case 5616:   return("ERR_DATABASE_EMPTY");
                        case 5617:   return("ERR_DATABASE_SCHEMA");
                        case 5618:   return("ERR_DATABASE_TOOBIG");
                        case 5619:   return("ERR_DATABASE_CONSTRAINT");
                        case 5620:   return("ERR_DATABASE_MISMATCH");
                        case 5621:   return("ERR_DATABASE_MISUSE");
                        case 5622:   return("ERR_DATABASE_NOLFS");
                        case 5623:   return("ERR_DATABASE_AUTH");
                        case 5624:   return("ERR_DATABASE_FORMAT");
                        case 5625:   return("ERR_DATABASE_RANGE");
                        case 5626:   return("ERR_DATABASE_NOTADB");


                    // Return Codes of the Trade Server

                        case 10004:  return("TRADE_RETCODE_REQUOTE");
                        case 10006:  return("TRADE_RETCODE_REJECT");
                        case 10007:  return("TRADE_RETCODE_CANCEL");
                        case 10008:  return("TRADE_RETCODE_PLACED");
                        case 10009:  return("TRADE_RETCODE_DONE");
                        case 10010:  return("TRADE_RETCODE_DONE_PARTIAL");
                        case 10011:  return("TRADE_RETCODE_ERROR");
                        case 10012:  return("TRADE_RETCODE_TIMEOUT");
                        case 10013:  return("TRADE_RETCODE_INVALID");
                        case 10014:  return("TRADE_RETCODE_INVALID_VOLUME");
                        case 10015:  return("TRADE_RETCODE_INVALID_PRICE");
                        case 10016:  return("TRADE_RETCODE_INVALID_STOPS");
                        case 10017:  return("TRADE_RETCODE_TRADE_DISABLED");
                        case 10018:  return("TRADE_RETCODE_MARKET_CLOSED");
                        case 10019:  return("TRADE_RETCODE_NO_MONEY");
                        case 10020:  return("TRADE_RETCODE_PRICE_CHANGED");
                        case 10021:  return("TRADE_RETCODE_PRICE_OFF");
                        case 10022:  return("TRADE_RETCODE_INVALID_EXPIRATION");
                        case 10023:  return("TRADE_RETCODE_ORDER_CHANGED");
                        case 10024:  return("TRADE_RETCODE_TOO_MANY_REQUESTS");
                        case 10025:  return("TRADE_RETCODE_NO_CHANGES");
                        case 10026:  return("TRADE_RETCODE_SERVER_DISABLES_AT");
                        case 10027:  return("TRADE_RETCODE_CLIENT_DISABLES_AT");
                        case 10028:  return("TRADE_RETCODE_LOCKED");
                        case 10029:  return("TRADE_RETCODE_FROZEN");
                        case 10030:  return("TRADE_RETCODE_INVALID_FILL");
                        case 10031:  return("TRADE_RETCODE_CONNECTION");
                        case 10032:  return("TRADE_RETCODE_ONLY_REAL");
                        case 10033:  return("TRADE_RETCODE_LIMIT_ORDERS");
                        case 10034:  return("TRADE_RETCODE_LIMIT_VOLUME");
                        case 10035:  return("TRADE_RETCODE_INVALID_ORDER");
                        case 10036:  return("TRADE_RETCODE_POSITION_CLOSED");
                        case 10038:  return("TRADE_RETCODE_INVALID_CLOSE_VOLUME");
                        case 10039:  return("TRADE_RETCODE_CLOSE_ORDER_EXIST");
                        case 10040:  return("TRADE_RETCODE_LIMIT_POSITIONS");
                        case 10041:  return("TRADE_RETCODE_REJECT_CANCEL");
                        case 10042:  return("TRADE_RETCODE_LONG_ONLY");
                        case 10043:  return("TRADE_RETCODE_SHORT_ONLY");
                        case 10044:  return("TRADE_RETCODE_CLOSE_ONLY");
                        case 10045:  return("TRADE_RETCODE_FIFO_ONLY");
                        case 10046:  return("TRADE_RETCODE_HEDGE_PROHIBITED");

                    // #ifdef __MQL4__
                    #else
                    // Client terminal or trade server error codes

                        case 0:      return("ERR_NO_ERROR");
                        case 1:      return("ERR_NO_RESULT");
                        case 2:      return("ERR_COMMON_ERROR");
                        case 3:      return("ERR_INVALID_TRADE_PARAMETERS");
                        case 4:      return("ERR_SERVER_BUSY");
                        case 5:      return("ERR_OLD_VERSION");
                        case 6:      return("ERR_NO_CONNECTION");
                        case 7:      return("ERR_NOT_ENOUGH_RIGHTS");
                        case 8:      return("ERR_TOO_FREQUENT_REQUESTS");
                        case 9:      return("ERR_MALFUNCTIONAL_TRADE");
                        case 64:     return("ERR_ACCOUNT_DISABLED");
                        case 65:     return("ERR_INVALID_ACCOUNT");
                        case 128:    return("ERR_TRADE_TIMEOUT");
                        case 129:    return("ERR_INVALID_PRICE");
                        case 130:    return("ERR_INVALID_STOPS");
                        case 131:    return("ERR_INVALID_TRADE_VOLUME");
                        case 132:    return("ERR_MARKET_CLOSED");
                        case 133:    return("ERR_TRADE_DISABLED");
                        case 134:    return("ERR_NOT_ENOUGH_MONEY");
                        case 135:    return("ERR_PRICE_CHANGED");
                        case 136:    return("ERR_OFF_QUOTES");
                        case 137:    return("ERR_BROKER_BUSY");
                        case 138:    return("ERR_REQUOTE");
                        case 139:    return("ERR_ORDER_LOCKED");
                        case 140:    return("ERR_LONG_POSITIONS_ONLY_ALLOWED");
                        case 141:    return("ERR_TOO_MANY_REQUESTS");
                        case 145:    return("ERR_TRADE_MODIFY_DENIED");
                        case 146:    return("ERR_TRADE_CONTEXT_BUSY");
                        case 147:    return("ERR_TRADE_EXPIRATION_DENIED");
                        case 148:    return("ERR_TRADE_TOO_MANY_ORDERS");
                        case 149:    return("ERR_TRADE_HEDGE_PROHIBITED");
                        case 150:    return("ERR_TRADE_PROHIBITED_BY_FIFO");


                    // Return Codes of the runtime system

                        case 4000:   return("ERR_NO_MQLERROR");
                        case 4001:   return("ERR_WRONG_FUNCTION_POINTER");
                        case 4002:   return("ERR_ARRAY_INDEX_OUT_OF_RANGE");
                        case 4003:   return("ERR_NO_MEMORY_FOR_CALL_STACK");
                        case 4004:   return("ERR_RECURSIVE_STACK_OVERFLOW");
                        case 4005:   return("ERR_NOT_ENOUGH_STACK_FOR_PARAM");
                        case 4006:   return("ERR_NO_MEMORY_FOR_PARAM_STRING");
                        case 4007:   return("ERR_NO_MEMORY_FOR_TEMP_STRING");
                        case 4008:   return("ERR_NOT_INITIALIZED_STRING");
                        case 4009:   return("ERR_NOT_INITIALIZED_ARRAYSTRING");
                        case 4010:   return("ERR_NO_MEMORY_FOR_ARRAYSTRING");
                        case 4011:   return("ERR_TOO_LONG_STRING");
                        case 4012:   return("ERR_REMAINDER_FROM_ZERO_DIVIDE");
                        case 4013:   return("ERR_ZERO_DIVIDE");
                        case 4014:   return("ERR_UNKNOWN_COMMAND");
                        case 4015:   return("ERR_WRONG_JUMP");
                        case 4016:   return("ERR_NOT_INITIALIZED_ARRAY");
                        case 4017:   return("ERR_DLL_CALLS_NOT_ALLOWED");
                        case 4018:   return("ERR_CANNOT_LOAD_LIBRARY");
                        case 4019:   return("ERR_CANNOT_CALL_FUNCTION");
                        case 4020:   return("ERR_EXTERNAL_CALLS_NOT_ALLOWED");
                        case 4021:   return("ERR_NO_MEMORY_FOR_RETURNED_STR");
                        case 4022:   return("ERR_SYSTEM_BUSY");
                        case 4023:   return("ERR_DLLFUNC_CRITICALERROR");
                        case 4024:   return("ERR_INTERNAL_ERROR");
                        case 4025:   return("ERR_OUT_OF_MEMORY");
                        case 4026:   return("ERR_INVALID_POINTER");
                        case 4027:   return("ERR_FORMAT_TOO_MANY_FORMATTERS");
                        case 4028:   return("ERR_FORMAT_TOO_MANY_PARAMETERS");
                        case 4029:   return("ERR_ARRAY_INVALID");
                        case 4030:   return("ERR_CHART_NOREPLY");
                        case 4050:   return("ERR_INVALID_FUNCTION_PARAMSCNT");
                        case 4051:   return("ERR_INVALID_FUNCTION_PARAMVALUE");
                        case 4052:   return("ERR_STRING_FUNCTION_INTERNAL");
                        case 4053:   return("ERR_SOME_ARRAY_ERROR");
                        case 4054:   return("ERR_INCORRECT_SERIESARRAY_USING");
                        case 4055:   return("ERR_CUSTOM_INDICATOR_ERROR");
                        case 4056:   return("ERR_INCOMPATIBLE_ARRAYS");
                        case 4057:   return("ERR_GLOBAL_VARIABLES_PROCESSING");
                        case 4058:   return("ERR_GLOBAL_VARIABLE_NOT_FOUND");
                        case 4059:   return("ERR_FUNC_NOT_ALLOWED_IN_TESTING");
                        case 4060:   return("ERR_FUNCTION_NOT_CONFIRMED");
                        case 4061:   return("ERR_SEND_MAIL_ERROR");
                        case 4062:   return("ERR_STRING_PARAMETER_EXPECTED");
                        case 4063:   return("ERR_INTEGER_PARAMETER_EXPECTED");
                        case 4064:   return("ERR_DOUBLE_PARAMETER_EXPECTED");
                        case 4065:   return("ERR_ARRAY_AS_PARAMETER_EXPECTED");
                        case 4066:   return("ERR_HISTORY_WILL_UPDATED");
                        case 4067:   return("ERR_TRADE_ERROR");
                        case 4068:   return("ERR_RESOURCE_NOT_FOUND");
                        case 4069:   return("ERR_RESOURCE_NOT_SUPPORTED");
                        case 4070:   return("ERR_RESOURCE_DUPLICATED");
                        case 4071:   return("ERR_INDICATOR_CANNOT_INIT");
                        case 4072:   return("ERR_INDICATOR_CANNOT_LOAD");
                        case 4073:   return("ERR_NO_HISTORY_DATA");
                        case 4074:   return("ERR_NO_MEMORY_FOR_HISTORY");
                        case 4075:   return("ERR_NO_MEMORY_FOR_INDICATOR");
                        case 4099:   return("ERR_END_OF_FILE");
                        case 4100:   return("ERR_SOME_FILE_ERROR");
                        case 4101:   return("ERR_WRONG_FILE_NAME");
                        case 4102:   return("ERR_TOO_MANY_OPENED_FILES");
                        case 4103:   return("ERR_CANNOT_OPEN_FILE");
                        case 4104:   return("ERR_INCOMPATIBLE_FILEACCESS");
                        case 4105:   return("ERR_NO_ORDER_SELECTED");
                        case 4106:   return("ERR_UNKNOWN_SYMBOL");
                        case 4107:   return("ERR_INVALID_PRICE_PARAM");
                        case 4108:   return("ERR_INVALID_TICKET");
                        case 4109:   return("ERR_TRADE_NOT_ALLOWED");
                        case 4110:   return("ERR_LONGS_NOT_ALLOWED");
                        case 4111:   return("ERR_SHORTS_NOT_ALLOWED");
                        case 4200:   return("ERR_OBJECT_ALREADY_EXISTS");
                        case 4201:   return("ERR_UNKNOWN_OBJECT_PROPERTY");
                        case 4202:   return("ERR_OBJECT_DOES_NOT_EXIST");
                        case 4203:   return("ERR_UNKNOWN_OBJECT_TYPE");
                        case 4204:   return("ERR_NO_OBJECT_NAME");
                        case 4205:   return("ERR_OBJECT_COORDINATES_ERROR");
                        case 4206:   return("ERR_NO_SPECIFIED_SUBWINDOW");
                        case 4207:   return("ERR_SOME_OBJECT_ERROR");
                        case 4210:   return("ERR_CHART_PROP_INVALID");
                        case 4211:   return("ERR_CHART_NOT_FOUND");
                        case 4212:   return("ERR_CHARTWINDOW_NOT_FOUND");
                        case 4213:   return("ERR_CHARTINDICATOR_NOT_FOUND");
                        case 4220:   return("ERR_SYMBOL_SELECT");
                        case 4250:   return("ERR_NOTIFICATION_ERROR");
                        case 4251:   return("ERR_NOTIFICATION_PARAMETER");
                        case 4252:   return("ERR_NOTIFICATION_SETTINGS");
                        case 4253:   return("ERR_NOTIFICATION_TOO_FREQUENT");
                        case 4260:   return("ERR_FTP_NOSERVER");
                        case 4261:   return("ERR_FTP_NOLOGIN");
                        case 4262:   return("ERR_FTP_CONNECT_FAILED");
                        case 4263:   return("ERR_FTP_CLOSED");
                        case 4264:   return("ERR_FTP_CHANGEDIR");
                        case 4265:   return("ERR_FTP_FILE_ERROR");
                        case 4266:   return("ERR_FTP_ERROR");
                        case 5001:   return("ERR_FILE_TOO_MANY_OPENED");
                        case 5002:   return("ERR_FILE_WRONG_FILENAME");
                        case 5003:   return("ERR_FILE_TOO_LONG_FILENAME");
                        case 5004:   return("ERR_FILE_CANNOT_OPEN");
                        case 5005:   return("ERR_FILE_BUFFER_ALLOCATION_ERROR");
                        case 5006:   return("ERR_FILE_CANNOT_DELETE");
                        case 5007:   return("ERR_FILE_INVALID_HANDLE");
                        case 5008:   return("ERR_FILE_WRONG_HANDLE");
                        case 5009:   return("ERR_FILE_NOT_TOWRITE");
                        case 5010:   return("ERR_FILE_NOT_TOREAD");
                        case 5011:   return("ERR_FILE_NOT_BIN");
                        case 5012:   return("ERR_FILE_NOT_TXT");
                        case 5013:   return("ERR_FILE_NOT_TXTORCSV");
                        case 5014:   return("ERR_FILE_NOT_CSV");
                        case 5015:   return("ERR_FILE_READ_ERROR");
                        case 5016:   return("ERR_FILE_WRITE_ERROR");
                        case 5017:   return("ERR_FILE_BIN_STRINGSIZE");
                        case 5018:   return("ERR_FILE_INCOMPATIBLE");
                        case 5019:   return("ERR_FILE_IS_DIRECTORY");
                        case 5020:   return("ERR_FILE_NOT_EXIST");
                        case 5021:   return("ERR_FILE_CANNOT_REWRITE");
                        case 5022:   return("ERR_FILE_WRONG_DIRECTORYNAME");
                        case 5023:   return("ERR_FILE_DIRECTORY_NOT_EXIST");
                        case 5024:   return("ERR_FILE_NOT_DIRECTORY");
                        case 5025:   return("ERR_FILE_CANNOT_DELETE_DIRECTORY");
                        case 5026:   return("ERR_FILE_CANNOT_CLEAN_DIRECTORY");
                        case 5027:   return("ERR_FILE_ARRAYRESIZE_ERROR");
                        case 5028:   return("ERR_FILE_STRINGRESIZE_ERROR");
                        case 5029:   return("ERR_FILE_STRUCT_WITH_OBJECTS");

                    #endif
                    // User defined error codes

                       default:      return("ERR_USER_ERROR" + ((add_user_code_no) ? (string(err_no)) : ""));

                }
            };


        #ifndef __MQL4__
            };

        #endif

    #endif


//
// END Debugging support
//*********************************************************************************************************************************************************/
#endif // LIB_DBG_DEBUG_TYPE_TO_STRING_MQH_INCLUDED
